from .template import Template
from typing import Dict
import os


class Templum:

    def __init__(self, source_dir: str, target_dir: str):
        self.source_dir = source_dir
        self.target_dir = target_dir

        self.files: Dict = {}
        self.templates: Dict = {}

    def read_all(self):
        for file in os.listdir(self.source_dir):
            if file.endswith('.templum'):
                template_name = file.replace('.templum', '')
                self.templates[template_name] = Template(template_name, file, self.read(file), self)
            else:
                self.files[file] = self.read(file)

    def write_all(self):
        for file, content in self.files.items():
            self.write(file, content)

    def read(self, file_name):
        with open(f'{self.source_dir}/{file_name}', 'r') as file:
            return file.read()

    def write(self, file_name, content):
        with open(f'{self.target_dir}/{file_name}', 'w') as file:
            file.write(content)

